// ************************************************************************ //
// Die in dieser Datei deklarierten Typen wurden aus Daten der unten
// beschriebenen WSDL-Datei generiert:

// WSDL     : http://qc.embarcadero.com/coBugCGI.EXE/wsdl/ICDSReportPublicInterface
// Codierung : utf-8
// Version: 1.0
// (08.06.2017 13:21:06 - - $Rev: 90173 $)
// ************************************************************************ //

unit ICDSReportPublicInterface1;

interface

uses Soap.InvokeRegistry, Soap.SOAPHTTPClient, System.Types, Soap.XSBuiltIns;

type

  // ************************************************************************ //
  // Die folgenden Typen, auf die im WSDL-Dokument Bezug genommen wird, sind in dieser Datei
  // nicht reprsentiert. Sie sind entweder Aliase[@] anderer reprsentierter Typen oder auf sie wurde Bezug genommen,
  // aber sie sind in diesem Dokument nicht[!] deklariert. Die Typen aus letzterer Kategorie
  // sind in der Regel vordefinierten/bekannten XML- oder Embarcadero-Typen zugeordnet; sie knnten aber auf 
  // ein inkorrektes WSDL-Dokument hinweisen, das einen Schematyp nicht deklariert oder importiert hat.
  // ************************************************************************ //
  // !:double          - "http://www.w3.org/2001/XMLSchema"[]
  // !:dateTime        - "http://www.w3.org/2001/XMLSchema"[]
  // !:float           - "http://www.w3.org/2001/XMLSchema"[]
  // !:base64Binary    - "http://www.w3.org/2001/XMLSchema"[]
  // !:string          - "http://www.w3.org/2001/XMLSchema"[]
  // !:boolean         - "http://www.w3.org/2001/XMLSchema"[]
  // !:int             - "http://www.w3.org/2001/XMLSchema"[]


  // ************************************************************************ //
  // Namespace : urn:CDSReportPublicInterfaceIntf-ICDSReportPublicInterface
  // soapAction: urn:CDSReportPublicInterfaceIntf-ICDSReportPublicInterface#%operationName%
  // Transport : http://schemas.xmlsoap.org/soap/http
  // Stil     : rpc
  // Verwenden von       : encoded
  // Bindung   : ICDSReportPublicInterfacebinding
  // Service   : ICDSReportPublicInterfaceservice
  // Port      : ICDSReportPublicInterfacePort
  // URL       : http://qc.embarcadero.com/coBugCGI.EXE/soap/ICDSReportPublicInterface
  // ************************************************************************ //
  ICDSReportPublicInterface = interface(IInvokable)
  ['{FDAB2580-6D47-1872-4181-A552162ACE00}']
    function  ModifyUser(const Sessionid: string; const EMail: string; const New_Passcode: string; const First_Name: string; const Last_Name: string; const Organization: string; 
                         const Title: string; const Phone: string; const Ext: string; const Fax: string; const URL: string; 
                         const Address: string; const City: string; const State: string; const Zip: string; const Country: string; 
                         const Auto_Notify: Boolean; const Threadview: Integer; const Digest_Mail: Boolean; const Max_return: Integer): Boolean; stdcall;
    function  GetUserInformation(const Sessionid: string; const Userid: Integer): TByteDynArray; stdcall;
    function  Login(const EMail: string; const Passcode: string; const ClientID: string; const BDN: string): TByteDynArray; stdcall;
    function  LoginWithCommunityID(const ID: Integer; const Passcode: string; const ClientID: string; const BDN: string): TByteDynArray; stdcall;
    function  CommunityIDExists(const ID: Integer): Boolean; stdcall;
    function  AddReport(const Sessionid: string; const Status: Integer; const Data_type: string; const Severity: Integer; const Project: Integer; const Version: string; 
                        const Area: Integer; const short_description: string; const Description: string; const Build: string; const Steps: string; 
                        const Platform_: Integer; const Workaround: string; const Locale: Integer): Integer; stdcall;
    function  ModifyReport(const Sessionid: string; const Defect_No: Integer; const Status: Integer; const Data_type: string; const Severity: Integer; const Project: Integer; 
                           const Version: string; const Area: Integer; const short_description: string; const Description: string; const Build: string; 
                           const Steps: string; const Platform_: Integer; const Workaround: string; const Locale: Integer): Boolean; stdcall;
    function  DeleteReport(const Sessionid: string; const Defect_No: Integer): Boolean; stdcall;
    function  WithdrawReport(const Sessionid: string; const Defect_No: Integer): Boolean; stdcall;
    function  SubmitAWorkaround(const Sessionid: string; const Defect_no: Integer; const Workaround: string): Boolean; stdcall;
    function  GetWorkarounds(const Sessionid: string): TByteDynArray; stdcall;
    procedure DeleteWorkaround(const Sessionid: string; const defectid: Integer); stdcall;
    procedure AddAttachment(const Sessionid: string; const defectid: Integer; const Attachment: string; const Name_: string); stdcall;
    procedure AddZipAttachment(const Sessionid: string; const defectid: Integer; const Attachment: string; const Name_: string); stdcall;
    procedure DeleteAttachment(const Sessionid: string; const defectid: Integer); stdcall;
    function  CommentOnReport(const Sessionid: string; const Defect_No: Integer; const ParentID: Integer; const Comment: string; const Publish: Boolean): Integer; stdcall;
    procedure DeleteComment(const Sessionid: string; const CommentID: Integer); stdcall;
    procedure EditComment(const Sessionid: string; const CommentID: Integer; const NewComment: string; const Publish: Boolean); stdcall;
    function  RateAReport(const Sessionid: string; const Defect_No: Integer; const Rate: Integer): Double; stdcall;
    function  VoteOnReport(const Sessionid: string; const Defect_No: Integer; const Vote: Boolean): Integer; stdcall;
    function  GetUserVotes(const Sessionid: string): TByteDynArray; stdcall;
    function  TrackAReport(const Sessionid: string; const Defect_No: Integer; const Tracking_Option: Integer): Boolean; stdcall;
    function  GetTrackedReports(const Sessionid: string): TByteDynArray; stdcall;
    function  GetUserReports(const Sessionid: string): TByteDynArray; stdcall;
    function  GetActiveUserVotes(const Sessionid: string): TByteDynArray; stdcall;
    function  GetUserComments(const Sessionid: string): TByteDynArray; stdcall;
    function  GetUserRatings(const Sessionid: string): TByteDynArray; stdcall;
    function  GetUserUnRated(const Sessionid: string; const project: Integer; const max: Integer; const Since: TXSDateTime; const LastDays: Integer; const status: Integer
                             ): TByteDynArray; stdcall;
    function  GetTrackingList(const Sessionid: string): string; stdcall;
    function  GetMailings(const Sessionid: string): string; stdcall;
    function  GetLookup(const Sessionid: string; const lookup_name: string): TByteDynArray; stdcall;
    function  GetOutLine(const Sessionid: string): TByteDynArray; stdcall;
    function  GetOutLineFromParent(const Sessionid: string; const ParentID: Integer): TByteDynArray; stdcall;
    function  GetProjects(const Sessionid: string): TByteDynArray; stdcall;
    function  GetQCConstants: TByteDynArray; stdcall;
    function  SaveQuery(const Sessionid: string; const Name_: string; const Query: string; const Default_: Boolean): Boolean; stdcall;
    function  RetrieveQuery(const Sessionid: string): string; stdcall;
    function  Search(const Sessionid: string; const First_Name: string; const Last_Name: string; const Defect_No: string; const RAID_No: string; const Status: string;
                     const Data_Type: string; const Severity: string; const Resolution: string; const Project: string; const Area: string; 
                     const Version: string; const keywords: string; const workarounds: Boolean; const Build_no: string; const Resolved_in_Build: string; 
                     const Since: TXSDateTime; const max_return: Integer; const ThePlatform: string; const IngoreAutoRep: string; const Start_Row: Integer; 
                     const S_Date_Reported: TXSDateTime; const E_Date_Reported: TXSDateTime; const S_Modified_date: TXSDateTime; const E_Modified_date: TXSDateTime): TByteDynArray; stdcall;
    function  SearchCount(const Sessionid: string; const First_Name: string; const Last_Name: string; const Defect_No: string; const RAID_No: string; const Status: string; 
                          const Data_Type: string; const Severity: string; const Resolution: string; const Project: string; const Area: string; 
                          const Version: string; const keywords: string; const workarounds: Boolean; const Build_no: string; const Resolved_in_Build: string; 
                          const Since: TXSDateTime; const ThePlatform: string; const IngoreAutoRep: string; const S_Date_Reported: TXSDateTime; const E_Date_Reported: TXSDateTime; 
                          const S_Modified_date: TXSDateTime; const E_Modified_date: TXSDateTime): Integer; stdcall;
    function  GetDuplicatesOf(const Sessionid: string; const defect_no: Integer): TByteDynArray; stdcall;
    function  GetDefect(const Sessionid: string; const defectid: Integer): TByteDynArray; stdcall;
    function  GetDefectAudits(const Sessionid: string; const defectid: Integer): TByteDynArray; stdcall;
    function  GetAttachmentList(const Sessionid: string; const defectid: Integer): TByteDynArray; stdcall;
    function  GetAttachment(const Sessionid: string; const defectid: Integer; const Files: string): TByteDynArray; stdcall;
    function  GetZipAttachment(const Sessionid: string; const defectid: Integer; const Files: string): TByteDynArray; stdcall;
    function  TopVoted(const Sessionid: string; const project: Integer; const max: Integer; const Since: TXSDateTime; const LastDays: Integer; const status: Integer
                       ): TByteDynArray; stdcall;
    function  TopRated(const Sessionid: string; const project: Integer; const max: Integer; const Since: TXSDateTime; const LastDays: Integer; const status: Integer
                       ): TByteDynArray; stdcall;
    function  NewestReports(const Sessionid: string; const project: Integer; const max: Integer; const Since: TXSDateTime; const LastDays: Integer; const status: Integer; 
                            const DateAsc: Boolean): TByteDynArray; stdcall;
    function  RecentlyModifiedReports(const Sessionid: string; const project: Integer; const max: Integer; const Since: TXSDateTime; const LastDays: Integer; const status: Integer; 
                                      const DateAsc: Boolean): TByteDynArray; stdcall;
    function  RecentlyClosedReports(const Sessionid: string; const project: Integer; const max: Integer; const Since: TXSDateTime; const LastDays: Integer; const DateAsc: Boolean
                                    ): TByteDynArray; stdcall;
    function  NewestComments(const Sessionid: string; const project: Integer; const max: Integer; const Since: TXSDateTime; const LastDays: Integer; const DateAsc: Boolean
                             ): TByteDynArray; stdcall;
    function  UserCommentReplies(const Sessionid: string; const project: Integer; const max: Integer; const Since: TXSDateTime; const LastDays: Integer; const DateAsc: Boolean
                                 ): TByteDynArray; stdcall;
    function  CurrentClientVersion(const ClientType: string): string; stdcall;
    function  LastInterfaceChange: TXSDateTime; stdcall;
    procedure CommentOnResolution(const Sessionid: string; const DefectID: Integer; const Comment: string); stdcall;
    function  GetUserStats(const sessionid: string): TByteDynArray; stdcall;
    function  IsValidSession(const sessionid: string): Boolean; stdcall;
    function  EmailPassword(const CommunityID: Integer; const EMail: string): Boolean; stdcall;
    function  Logout(const Sessionid: string): Boolean; stdcall;
    procedure RegisterForBetaTesting(const Sessionid: string; const FieldTest: string; const FieldTestUser: string; const FieldTestPassword: string); stdcall;
    function  GetAreaNotify(const Sessionid: string): TByteDynArray; stdcall;
    function  AddAreaNotify(const Sessionid: string; const Project: Integer; const AreaID: Integer; const notify_event: Integer): TByteDynArray; stdcall;
    function  DelAreaNotify(const Sessionid: string; const Project: Integer; const Area: string; const notify_event: Integer): TByteDynArray; stdcall;
    function  addClient(const Sessionid: string; const ClientVersion: string; const ISActive: string): Integer; stdcall;
    procedure deleteClient(const Sessionid: string; const Client_no: Integer); stdcall;
    procedure editClient(const Sessionid: string; const ClientVersion: string; const ISActive: string; const Client_no: Integer); stdcall;
    function  getClient(const Sessionid: string): TByteDynArray; stdcall;
    function  getMessageOfTheDay(const Sessionid: string; const ALL: string): string; stdcall;
    function  getNotificationDefaults(const SessionID: string): TByteDynArray; stdcall;
    procedure setNotificationDefaults(const SessionID: string; const NotificationDefaults: TByteDynArray); stdcall;
    function  getDefaults(const SessionID: string): TByteDynArray; stdcall;
    procedure setDefaults(const SessionID: string; const Defaults: TByteDynArray); stdcall;
    function  VoteOnReport2(const Sessionid: string; const Defect_No: Integer; const Num_Votes: Integer): string; stdcall;
    function  getOutLineFromProjectW(const Sessionid: string; const Project: Integer): TByteDynArray; stdcall;
    function  getListNames(const Sessionid: string): TByteDynArray; stdcall;
    function  updateListNames(const SessionID: string; const ListID: Integer; const ListName: string): Integer; stdcall;
    function  getListReports(const Sessionid: string): TByteDynArray; stdcall;
    function  updateListReports(const SessionID: string; const ListReportsID: Integer; const ListID: Integer; const Defect_no: Integer; const Estimate: Single; const Actual: Single
                                ): Integer; stdcall;
    function  getListSecurity(const Sessionid: string): TByteDynArray; stdcall;
    function  updateListSecurity(const SessionID: string; const ListSecurityID: Integer; const ListID: Integer; const aUserID: Integer): Integer; stdcall;
    function  addEmailsToListSecurity(const Sessionid: string; const Listid: Integer; const Emails: string): TByteDynArray; stdcall;
  end;

function GetICDSReportPublicInterface(UseWSDL: Boolean=System.False; Addr: string=''; HTTPRIO: THTTPRIO = nil): ICDSReportPublicInterface;


implementation
  uses System.SysUtils;

function GetICDSReportPublicInterface(UseWSDL: Boolean; Addr: string; HTTPRIO: THTTPRIO): ICDSReportPublicInterface;
const
  defWSDL = 'http://qc.embarcadero.com/coBugCGI.EXE/wsdl/ICDSReportPublicInterface';
  defURL  = 'http://qc.embarcadero.com/coBugCGI.EXE/soap/ICDSReportPublicInterface';
  defSvc  = 'ICDSReportPublicInterfaceservice';
  defPrt  = 'ICDSReportPublicInterfacePort';
var
  RIO: THTTPRIO;
begin
  Result := nil;
  if (Addr = '') then
  begin
    if UseWSDL then
      Addr := defWSDL
    else
      Addr := defURL;
  end;
  if HTTPRIO = nil then
    RIO := THTTPRIO.Create(nil)
  else
    RIO := HTTPRIO;
  try
    Result := (RIO as ICDSReportPublicInterface);
    if UseWSDL then
    begin
      RIO.WSDLLocation := Addr;
      RIO.Service := defSvc;
      RIO.Port := defPrt;
    end else
      RIO.URL := Addr;
  finally
    if (Result = nil) and (HTTPRIO = nil) then
      RIO.Free;
  end;
end;


initialization
  { ICDSReportPublicInterface }
  InvRegistry.RegisterInterface(TypeInfo(ICDSReportPublicInterface), 'urn:CDSReportPublicInterfaceIntf-ICDSReportPublicInterface', 'utf-8');
  InvRegistry.RegisterDefaultSOAPAction(TypeInfo(ICDSReportPublicInterface), 'urn:CDSReportPublicInterfaceIntf-ICDSReportPublicInterface#%operationName%');
  { ICDSReportPublicInterface.AddReport }
  InvRegistry.RegisterParamInfo(TypeInfo(ICDSReportPublicInterface), 'AddReport', 'Platform_', 'Platform', '');
  { ICDSReportPublicInterface.ModifyReport }
  InvRegistry.RegisterParamInfo(TypeInfo(ICDSReportPublicInterface), 'ModifyReport', 'Platform_', 'Platform', '');
  { ICDSReportPublicInterface.AddAttachment }
  InvRegistry.RegisterParamInfo(TypeInfo(ICDSReportPublicInterface), 'AddAttachment', 'Name_', 'Name', '');
  { ICDSReportPublicInterface.AddZipAttachment }
  InvRegistry.RegisterParamInfo(TypeInfo(ICDSReportPublicInterface), 'AddZipAttachment', 'Name_', 'Name', '');
  { ICDSReportPublicInterface.SaveQuery }
  InvRegistry.RegisterParamInfo(TypeInfo(ICDSReportPublicInterface), 'SaveQuery', 'Name_', 'Name', '');
  InvRegistry.RegisterParamInfo(TypeInfo(ICDSReportPublicInterface), 'SaveQuery', 'Default_', 'Default', '');

end.